<?php
/*
OekakiBBS parse code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wax Poteto by Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 5.5.13 - Last modified 5/17/2007
*/


// Error reporting
function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	exit ($exit_err);
}

// Waccoon: Fix for FTP'd uploads
function kill_locked_file($filename) {
	if (file_exists ($filename) && !is_writable ($filename)) {
		// Ouch
		if (! @chmod($filename, 0664)) {
			if (! @unlink ($filename)) {
				return 0;
			}
		}
	}
	return 1;
}


require ('globals.php');
require ('paintsave.php');


// Get IP.
$address = $_SERVER['REMOTE_ADDR'];
if (!empty ($address)) {
	// Get user's hostname.
	$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
} else {
	// Allows testing w/out a server
	$address = 'invalid';
	$hostname = 'invalid';
}


// Get raw POST data (reference test saves memory)
if (empty ($HTTP_RAW_POST_DATA)) {
	$raw_buffer = file_get_contents ('php://input');
} else {
	$raw_buffer =& $HTTP_RAW_POST_DATA;
}


// Test input
if (empty ($raw_buffer)) {
	// No data to save!
	quiet_exit('No data to save!  Try again.');
}


$start = strpos ($raw_buffer, 'Content-type:');
$middle = 0;
$end = 0;


// Get proper picture number
if ($edit != '') {
	$resno = $edit;
} else {
	$resno = get_new_picnumber();
}


while ($start) {
	// Get each instance of "Content-type" and save

	$end = strpos ($raw_buffer, 'Content-type:', $start + 1);
	$middle = strpos ($raw_buffer, "\r", $start);
	$type = substr ($raw_buffer, $start + 13, $middle - $start - 13);
	$middle = strpos ($raw_buffer, "\r", $middle + 1);

	if ($end === FALSE) {
		$end = NULL;
		$data = substr ($raw_buffer, $middle + 2);
	} else {
		$data = substr ($raw_buffer, $middle + 2, $end - $middle - 2);
	}
	$start = $end;

	if ($type == 'image/0') {
		// 'image/0' == PNG
		$image_filenamejpg = $OPpics.'/'.$resno.'.jpg';
		$image_filename = $OPpics.'/'.$resno.'.png';

		// Wac: Check if file is writable
		// (resolves evil GID conflict with obsoleted recover code and FTP'd uploads)
		$delete_filename = $OPpics.'/'.$resno;
		kill_locked_file ($delete_filename.'.png');
		kill_locked_file ($delete_filename.'.jpg');
		kill_locked_file ($delete_filename.'.pch');
		kill_locked_file ($delete_filename.'.oeb');


		if ($fp = fopen ($image_filename, 'wb')) {
			// Write main file
			fwrite ($fp, $data);
			fclose ($fp);

			if ($jpgcompression == 'yes') {
				make_thumbnail($image_filename, $image_filenamejpg);
			}
		} else {
			error_log ('Cannot save image!  User: '.$username.' - Number: '.$resno);
		}
	}

	if ($type == 'animation/') {
		$image_filename = $OPpics.'/'.$resno.'.oeb';

		if ($fp = fopen ($image_filename,'wb')) {
			// Write main file
			fwrite ($fp, $data);
			fclose ($fp);
		}
	}
}

if ($edit != '') {
	$edittime2 = time() - $_REQUEST['edittimes'];
	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
} else {
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE PIC_ID='$resno'");
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$resno'");
	$thetime = time() - $edittimes;

	$ani_sql = 'animation=0';
	if ($mode == 'ani')
		$ani_sql = 'animation=1';

	//database insertion
	// Waccoon: Pseudo-fixed to prevent infinite loop!  WTF?
	$insert = 0;
	$tries = 50;
	while ($insert == 0) {
		if ($tries-- <= 0) {
			$fail = 1;
			$insert = 1;
		}
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$username', postdate=NOW(), hostname='$hostname', comment='', PIC_ID='$resno', IP='{$address}', datatype='1', {$ani_sql}, edittime='$thetime'");
		$result = mysql_query ("SELECT COUNT(*) AS rowcount FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$resno'");
		$therow = mysql_fetch_array ($result);
		if ($therow['rowcount'] == 1) {
			$insert = 1;
		}
	}
}

mysql_close ($dbconn);

?>