<?php
/*
Animation code by Marcello (http://www.cellosoft.com). Modified by RanmaGuy. Used with permission. This file is not to be used with any other script other than OekakiPoteto.

Wax Poteto by Marc "Waccoon" Leveille, http://www.NineChime.com/products/
Version 5.5.13 - Last modified 5/17/2007
*/


// Error reporting
function print_ok() {
	global $dbconn;
	@mysql_close ($dbconn);

	header('Content-type: text/plain');
	exit ('ok');
}
function quiet_exit($exit_err) {
	global $dbconn;
	@mysql_close ($dbconn);

	header ('Content-type: text/plain');
	echo "error\n";
	exit ($exit_err);
}

// Fix for FTP'd uploads
function kill_locked_file($filename) {
	// NOTE: silence all errors!
	if (file_exists ($filename) && !is_writable ($filename)) {
		// Ouch
		if (! @chmod($filename, 0664)) {
			if (! @unlink ($filename)) {
				return 0;
			}
		}
	}
	return 1;
}


require ('globals.php');
require ('paintsave.php');


// Get IP.
$address = $_SERVER['REMOTE_ADDR'];
if (!empty ($address)) {
	// Get user's hostname.
	$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
} else {
	// Allows testing w/out a server
	$address = 'invalid';
	$hostname = 'invalid';
}


// Get raw POST data (reference test saves memory)
if (empty ($HTTP_RAW_POST_DATA)) {
	$raw_buffer = file_get_contents ('php://input');
} else {
	$raw_buffer =& $HTTP_RAW_POST_DATA;
}


// Test input
if (empty ($raw_buffer)) {
	// No data to save!
	quiet_exit('No data to save!  Try again.');
}


// Check for excess data
if ($_SERVER['CONTENT_LENGTH'] > $anisize) {
	quiet_exit('Excess data! (over '.$anisize.' bytes)');
}


$data_type = 'image';
$params = array('sid'=>$_GET['sid'],'time'=>$_GET[time]);
$vars = array ('sid'=>1,'time'=>1,'uid'=>1,'width'=>1,'height'=>1);


if (substr ($raw_buffer, 0, 1) == 'P') {
	$image['h_length'] = substr ($raw_buffer, 1, 8);
	$image['h_length'] = (int) $image['h_length'];
	$image['h_data']   = substr ($raw_buffer, 9, $image['h_length']);

	$a = explode(';', $image['h_data']);
	for ($i = count ($a); --$i >= 0;) {
		$b = split('=', $a[$i]);
		if ($vars[$b[0]])
			$params[$b[0]] = $b[1];
	}
}


// PaintBBS data
if (substr($raw_buffer,0,1) == 'P') {
	$image['o_length'] = substr($raw_buffer, $image['h_length'] + 9, 8);
	$image['o_length'] = (int) $image['o_length'];
	$image['o_data']   = substr($raw_buffer, $image['h_length'] + 19, $image['o_length']);

	$image['t_length'] = substr($raw_buffer, $image['h_length'] + $image['o_length'] + 19, 8);
	$image['t_length'] = (int) $image['t_length'];
	if ($image['t_length'] > 0) {
		$data_type = 'imageplus';
		$image['t_data'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + 27, $image['t_length']);
	}

	$image['t2_length'] = substr($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 27, 8);
	$image['t2_length'] = (int) $image['t2_length'];
	if ($image['t2_length'] > 0) {
		$image['t2_data'] = substr ($raw_buffer, $image['h_length'] + $image['o_length'] + $image['t_length'] + 35, $image['t2_length']);
	}
}



if ($edit != '') {
	$resno = $edit;

	$image_filenamejpg = $OPpics.'/'.$resno.'.jpg';
	$image_filename = $OPpics.'/'.$resno.'.png';
	$anim_filename = $OPpics.'/'.$resno.'.pch';
	$edittime2 = time() - $edittimes;

	$result2 = mysql_query ("UPDATE {$OekakiPoteto_Prefix}oekakidta SET edittime=(edittime + $edittime2) WHERE PIC_ID='$resno'");
} else {
	$resno = get_new_picnumber();

	$image_filenamejpg = $OPpics.'/'.$resno.'.jpg';
	$image_filename = $OPpics.'/'.$resno.'.png';
	$anim_filename = $OPpics.'/'.$resno.'.pch';
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakicmt WHERE PIC_ID='$resno'");
	$result = mysql_query ("DELETE FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$resno'");
	$thetime = time() - $edittimes;

	$ani_sql = 'animation=0';
	if ($data_type == 'imageplus') {
		$ani_sql = 'animation=1';
	}

	// Insert the picture into the database
	// Waccoon: Pseudo-fixed to prevent infinite loop!  WTF?
	$insert = 0;
	$tries = 50;
	while ($insert == 0) {
		if ($tries-- <= 0) {
			$fail = 1;
			$insert = 1;
		}
		$result = mysql_query ("INSERT INTO {$OekakiPoteto_Prefix}oekakidta SET usrname='$username', hostname='$hostname', comment='', postdate=NOW(), PIC_ID='$resno', IP='{$address}', {$ani_sql}, edittime='$thetime'");

		$result = mysql_query ("SELECT COUNT(*) AS rowcount FROM {$OekakiPoteto_Prefix}oekakidta WHERE PIC_ID='$resno'");
		$r_rows = mysql_fetch_array ($result);
		if ($r_rows['rowcount'] == 1) {
			$insert = 1;
		}
	}
}


// Wac: Check if file is writable
// (resolves evil GID conflict with obsoleted recover code and FTP'd uploads)
$delete_filename = $OPpics.'/'.$resno;
kill_locked_file ($delete_filename.'.png');
kill_locked_file ($delete_filename.'.jpg');
kill_locked_file ($delete_filename.'.pch');
kill_locked_file ($delete_filename.'.oeb');


if ($fp = @fopen ($image_filename, 'wb')) {
	// Write main file
	fwrite ($fp,$image['o_data']);
	fclose ($fp);
	
	// Verify size matches applet parameters
	if ($params['width'] && $params['height'] && ($params['width'] != $info[0] || $params['height'] != $info[1])) {
		quiet_exit("Stored image size doesn't match!\n({$info[0]}x{$info[1]} != {$params['width']}x{$params['height']})");
	}

	if ($jpgcompression == 'yes') {
		make_thumbnail($image_filename, $image_filenamejpg);
	}

	if ($image['t_data']) {
		// Write animation file (if exists)
		if ($fp = fopen ($anim_filename, 'wb')) {
			fwrite ($fp, $image['t_data']);
			fclose ($fp);
			print_ok();
		}
	} else {
		print_ok();
	}
} else {
	// Waccoon: Silence PHP errors or else quiet_exit() won't work!
	error_log ('Cannot save image!  User: '.$username.' - Number: '.$resno);
}

quiet_exit("Transfer error!  Take a screenshot of your image before trying again.");

?>